
/**
 * CCServerImpl.java
 * This is the class that actually implements the interface to native apps
 *
 * Created: Tue May 25 12:35:20 1999
 *
 * @author Nathan Stevens
 * @version 0.1
 */
import java.io.*;
import java.rmi.*;

public class CCServerImpl extends Thread
{
  private int[] fa;
  private CCServerManager ccsm;
  // Constructor

  public void setSM(CCServerManager ccsm)
    {
      this.ccsm = ccsm;
    }
  // Dummy run method
  public void run()
    {
      try
	{
          while(true)
	    {
              sleep(Long.MAX_VALUE);
	    }
	}
      catch(InterruptedException ie){}
    }

  // Dummy getStatus Method
  public String[] getStatus()
    {
      String[] blah = {"s"};
      return blah;
    }
   
  // Dummy stop job method
  public void StopJob() {};
  
  // Dummy isActive
  public boolean isActive()
    {
     return false;
    }

  // Dummy runApp method
  public boolean runApp(String[] command)
    {
      return false;
    }
    
  //Dummy getAppBin method
  public String getAppBin()
    {
      return "s";
    }

  // Dummy get working directory method
  public String getWorkDir()
    {
      return "s";
    }
      
  // the put file method
  synchronized public boolean putFile(int[] fileArray, String filename)
    {
      try
	{
          File nf = new File(filename);
          BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(nf));
          for(int i = 0; i < fileArray.length; i++)
            out.write(fileArray[i]);
          
          out.flush();
          out.close();
	}
      catch(IOException e)
	{
          System.out.println(e.toString());
          return false;
	}

      return true;
    }  

  //Method to get file
  synchronized public int[] getFile(String filename)
    {
      //Create the file object and see if it exist
      try
	{
          File nf = new File(filename);
          if(nf.isFile() && nf.canRead())
	    {
              fa = new int[(int)nf.length()];
              BufferedInputStream in = new BufferedInputStream(new FileInputStream(nf));
             
	      // might hava a problem with this
              for(int i = 0; i < fa.length; i++)
                fa[i] = in.read();

              in.close();
	    }
	}
      catch(IOException e)
	{
          System.out.println(e.toString());
	}              
      return fa;
    }

  synchronized public boolean delFile(String filname)
    {
      //code later
      return false;
    }
  
  //method to list the files in a directory  
  synchronized public String[] getFileList(String wdir, String name, String extension)
    {
      // create the file object 
      System.out.println("get file method called " + wdir);  //debug code

      String[] contents;
      FilenameFilter select = new FileListFilter(name, extension);
      File workDir = new File(wdir);
     
      contents = workDir.list(select);
      return contents;      
    }

  // Method to set the thread to null
  synchronized public void setNull(int id)
    {
      try
	{     
           ccsm.Stop(id);
	}
      catch(RemoteException re){}                  
    }

  // Method to tell the Server thread wheather to wait for the client to
  // get the results or just stop when it done
  public void setRetrieve(boolean r){}
}











